#include <stdio.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>

#include "tsc.h"

void init_data(int *x, int size)
{
    int i;
    for (i=0; i<size; ++i)
       x[i]=i;        
}

int *x;

int main(int argc, char *argv[])
{
    int i, j, d, n, c, t;
    double time;

    if (argc < 3) {
        fprintf(stderr, "Usage: %s <delta> <size>\n", argv[0]);
        return 1;
    }

    calibrate_tsc(0);

    d = atoi(argv[1]);
    n = atoi(argv[2]);
    
    c = 10000000;
    
    fprintf(stderr, "reps=%d, delta=%d, n=%d\n", c, d, n);

    
    x = malloc(sizeof(int)*n);
    if (!x) {
        fprintf(stderr, "Memory allocation error\n");
        return 1;
    }
    
    init_data(x, n);
    
    start_timing(1);
    for (i=j=t=0; i<c; ++i) {
        t += x[j];
        j += d;
        if (j >= n)
            j -= n;
    }
    stop_timing(1);
    
    time = timing_result();
    fprintf(stderr, "timing=%.3f msec -- %.3f nsec/access, t=%d\n", time, 
                        time*1000000.0/c, t);
    printf("%d %d %d %f\n", c, d, n, time);
    return 0;
}

